import java.awt.*;
class Rechteck extends Form{
    //eigenschaften
    //ererbte eigenschaften: int origX, int origY, farbe
    //eingabeString
    private int breite;
    private int hoehe;
    //eingabe String enthaelt benutzereingabe mit neuen objekteigenschaften
    private String eingabeString; 
    
    //konstruktor
    public Rechteck(int origXPar, int origYPar,
                    int breitePar, int hoehePar, Color farbePar) {
        origX = origXPar;
        origY = origYPar;
        breite = breitePar;
        hoehe = hoehePar;
        farbe = farbePar;
    }
        
    //hier wird die abstrakte methode zeichnen 
    //der superklasse ueberschrieben
    public void zeichnen(Graphics g) {
        System.out.println("zeichnen aufgerufen");
        if (isSelected)
            g.setColor(new Color(200,200,200));
        else
            g.setColor(farbe);
        g.drawRect(origX, origY-hoehe, breite, hoehe);
    }
    
    //setSelection selektiert das Rechteck, wenn der 
    //uebergebene punkt innerhalb liegt
    public void setSelection(int x, int y) {
//        if ((x > x1) && (x < x2) && (y > y1) && (y < y2)) {
        if ((x > origX) && (x < (origX+breite)) && 
            (y > origY-hoehe) && (y < (origY))) {
            isSelected = isSelected ^ true;
            System.out.println("zustand selektiert :" + isSelected);
        }
    }
    public void setSelection(boolean isSelectedPar){
        isSelected = isSelectedPar;
    }
    
    //zurueckliefern eines textstrings, der alle eigenschaften auflistet
    public String getAlle() {
        return "aktuelle eigenschaften:\n" + 
        "x=" + Integer.toString(origX) + ",   " +
        "y=" + Integer.toString(origY) + "\n" +
        "b=" + Integer.toString(breite) + ",   " +
        "h=" + Integer.toString(hoehe) + "\n" +
        "rgb=" +
        farbe.getRed() + " " + farbe.getGreen() + " " + farbe.getBlue();
    }
    
/*    //empfangen eines textstrings, der benutzereingaben mit 
    //neuen eigenschaftgen enthaelt
    public void processEingabeString(String eingabeStringPar) {
        //ein String-array fuer die einzeleingaben
        String[] splitedString = new String[5];
        eingabeString = eingabeStringPar;
        System.out.println("eingabe war: " + eingabeString);
            
        //zaehler i auf 0
        int i = 0;
        int kommaIndex = 0;
        while(true) {
            //position des ersten kommas suchen; indexOf(44) liefert -1
            //wenn kein komma mehr im string
            kommaIndex = eingabeString.indexOf(44);
            if (kommaIndex != -1) {
                System.out.println("index= " + kommaIndex);
                //erster teilstring bis komma in array kopieren
                splitedString[i] = eingabeString.substring(0,kommaIndex);
                //leerzeichen entfernen
                splitedString[i] = splitedString[i].trim();
                eingabeString = eingabeString.substring(kommaIndex+1);
                i++;
            }
            else break;
        }
        //falls der eingabestring garkeine kommas enthaelt:
        splitedString[i] = eingabeString;
        splitedString[i] = splitedString[i].trim();  */
        
    //diese methode verarbeitet ein string-array, das die benutzereingaben beim aendern 
    //der objekteigenschaften enthlt. die elemente dieses array bestehen aus einem
    //namen der zu aendernden eigenschaft und dem zugehrigen wert. 
    //trennzeichen ist "=" (ascii 61)
    public void parseSplittedString() {
        for(int j=0; j<=laengeSplittedString; j++) {
            //eigenschaftsnamen abtrennen
            String eigenschaft = splittedString[j].substring(0,splittedString[j].indexOf(61)).trim();
            System.out.println("eigenschaft :" + eigenschaft);
            //zugehoerigen wert abtrennen
            String wert = splittedString[j].substring(splittedString[j].indexOf(61)+1).trim();
            System.out.println("wert :" + wert);
            if(eigenschaft.equals("x")){
                origX = Integer.parseInt(wert);
            }
            if(eigenschaft.equals("y")){
                origY = Integer.parseInt(wert);
            }
            if(eigenschaft.equals("b")){
                breite = Integer.parseInt(wert);
            }
            if(eigenschaft.equals("h")){
                hoehe = Integer.parseInt(wert);
            }
            System.out.println("origX: " + origX);
            
            
        }
        
        
   }
    
}
