import java.awt.*;
import java.io.*;

abstract class Form implements Serializable{
    protected int origX;
    protected int origY;
    protected boolean isSelected;
    protected Color farbe = Color.gray;
    protected String[] splittedString = new String[8];
    protected int laengeSplittedString = 0;
     
    public void setFarbe(Color farbe) {
        this.farbe = farbe;
    }
    
    public Color getFarbe() {
        return farbe;
    }
    
    
    //getSelection liefert true oder false, je nachdem ob das form-objekt
    //selektiert ist
    public boolean getSelection() {
        return isSelected;
    }
    
    public void setOrigin(int origXPar, int origYPar) {
        origX = origXPar;
        origY = origYPar;
    }
    
     public void setOrigX(int origXPar) {
         origX = origXPar;
    }
    
     public void setOrigY(int origYPar) {
         origY = origYPar;
    }
    
    //empfangen eines textstrings, der benutzereingaben mit 
    //neuen eigenschaftgen enthaelt und umwandeln in ein
    //string-array, das die durch komma separierten einzelstrings 
    //enthaelt; entfernen von fhrenden und folgenden leerzeichen
    public void setSplittedString(String eingabeString) {
        System.out.println("eingabe war: " + eingabeString);
        
        //zaehlvariable ist laengeSplittedString
        int kommaIndex = 0;
        while(true) {
            //position des ersten kommas suchen; indexOf(44) liefert -1
            //wenn kein komma mehr im string
            kommaIndex = eingabeString.indexOf(44);
            if (kommaIndex != -1) {
                System.out.println("index= " + kommaIndex);
                //erster teilstring bis komma in array kopieren
                splittedString[laengeSplittedString] = 
                   eingabeString.substring(0,kommaIndex);
                //leerzeichen entfernen
                splittedString[laengeSplittedString] = 
                   splittedString[laengeSplittedString].trim();
                eingabeString = eingabeString.substring(kommaIndex+1);
                laengeSplittedString++;
            }
            else break;
        }
        //falls der eingabestring garkeine kommas enthaelt:
        splittedString[laengeSplittedString] = eingabeString;
        splittedString[laengeSplittedString] = 
           splittedString[laengeSplittedString].trim();
    }
    
    public String[] getSplittedString() {
        return splittedString;
    }
    
    
    //alle formen-unterklassen muessen folgende methoden ueberschreiben
    public abstract void zeichnen(Graphics g);
    public abstract void setSelection(int x, int y);
    public abstract void setSelection(boolean isSelectedPar);
    public abstract String getAlle();
    public abstract void parseSplittedString();
}

